function MCcmd.location()
   messagef("X: %.4f Y: %.4f Z: %.4f", player_x, player_y, player_z)
   messagef("Pitch: %.2f Yaw: %.2f", player_pitch, player_yaw)
end
function MCcmd.reload()
   local s,e = pcall(dofile,P"cmds.lua")
   if not s then messagef("! %s", e)
   else messagef("Reloaded.") end
end
function MCcmd.beacon(x,y,z)
   mode = nil
   beacon_x = assert(tonumber(x))
   beacon_y = assert(tonumber(y))
   beacon_z = assert(tonumber(z))
   mode = "beacon"
end
function MCcmd.find(...)
   mode = nil
   valid = nil
   find_types = {...}
   assert(find_types[1])
   for n=1,#find_types do
      find_types[n] = assert(tonumber(find_types[n]))
   end
   mode = "find"
end
function MCcmd.edits()
   messagef("Outstanding edits: %i", #edits)
   local bulks,kills,multis,ones,unknowns = 0,0,0,0,0
   local q = {}
   for n=1,#edits do
      local edit = edits[n]
      if edit.type == "one" then ones = ones + 1
      elseif edit.type == "multi" then multis = multis + 1
      elseif edit.type == "kill" then kills = kills + 1
      elseif edit.type == "bulk" then bulks = bulks + 1
      else
	 local t = tostring(edit.type)
	 if not q[t] then q[t] = #q+1 q[#q+1] = t end
	 unknowns = unknowns + 1
      end
   end
   messagef("%i bulks, %i kills, %i multis, %i ones, %i (%s)",
	    bulks, kills, multis, ones, unknowns, table.concat(q,","))
end
function MCcmd.trans(...)
  mode = nil
  valid = nil
  local tr_types = {...}
  trans_types= {}
  assert(tr_types[1])
  for n=1,#tr_types do
    trans_types[string.char(tr_types[n])] = true
  end
  mode = "trans"
end
function MCcmd.stop_caring()
  not_caring= true
end
function MCcmd.start_caring()
  not_caring= nil
end
