local lport = assert(tonumber(arg[1]),"not a valid ListenPort")
local tip = arg[2]
local tport = assert(tonumber(arg[3]),"not a valid TargetPort")

local listensock = assert(SC.Construct("TCPListenSocket"))
listensock:SetAddressPart("Host", "*")
listensock:SetAddressPart("Port", lport)
assert(listensock:ApplyAddress())
listensock:SetBlocking(true)
print("listening on *:"..lport)
repeat
   csock = listensock:Accept()
until csock
listensock = nil
print("connecting to "..tip..":"..tport)
ssock = assert(SC.Construct("TCPSocket"))
ssock:SetAddressPart("Host", tip)
ssock:SetAddressPart("Port", tport)
assert(ssock:ApplyAddress())

other = {[ssock]=csock,[csock]=ssock}
print("OK")
